#region REFERENCES

using System;
using System.Diagnostics;
using System.Threading;
using System.Windows.Forms;
using System.Windows.Media;

using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.Helpers;
using Styx.Plugins;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;

#endregion

namespace Plugins.AbStuckHelper
{
    public class AbStuckHelper : HBPlugin
    {
        private static readonly Stopwatch SwStuckTimer = new Stopwatch();
        private static readonly LocalPlayer Me = StyxWoW.Me;
        private readonly Version _version = new Version(1, 0, 0, 0);
        private WoWPoint _wpLast;

        public override string Name
        {
            get { return "ArchaeologyBuddy Stuck Helper"; }
        }

        public override string Author
        {
            get { return "Helper"; }
        }

        public override Version Version
        {
            get { return _version; }
        }

        public override void Initialize()
        {
            _wpLast = Me.Location;
            SwStuckTimer.Reset();
            Logging.Write(Colors.Yellow, "[ArchaeologyBuddy Stuck Helper]: Initialized.");
        }

        public override void Pulse()
        {
            // update game objects -- needed?
            ObjectManager.Update();

            // Only check for stuck if we're flying
            if (Me.Mounted)
            {
                // Ok, we'er flying, make sure timer is running
                if (!SwStuckTimer.IsRunning)
                    SwStuckTimer.Start();
                    // We're flying, timer is running, check if we're stuck about every 9 seconds
                else if (SwStuckTimer.Elapsed.TotalSeconds > 9.0)
                {
                    // If we're flying, we should have moved 30 or more, if not, we're stuck!
                    if (Me.Location.Distance(_wpLast) < 30)
                    {
                        var rand = new Random((int) DateTime.Now.Ticks);
                        var next = rand.Next(-2, 2);

                        if (next > 1 && Me.IsFlying)
                        {
                            Logging.Write(Colors.Yellow, "[ArchaeologyBuddy Stuck Helper]: We're stuck! Descending for 5 seconds!");

                            KeyboardManager.PressKey((char) Keys.X);
                            Thread.Sleep(5000);
                            KeyboardManager.ReleaseKey((char) Keys.X);
                        }
                        else if (next > 0 && next <= 1)
                        {
                            Logging.Write(Colors.Yellow, "[ArchaeologyBuddy Stuck Helper]: We're stuck! Going forward for 1 second!");

                            KeyboardManager.PressKey((char) Keys.W);
                            Thread.Sleep(1000);
                            KeyboardManager.ReleaseKey((char) Keys.W);
                        }
                        else if (next < 0 && next >= -1)
                        {
                            Logging.Write(Colors.Yellow, "[ArchaeologyBuddy Stuck Helper]: We're stuck! Going backwards for 1 second!");

                            KeyboardManager.PressKey((char) Keys.S);
                            Thread.Sleep(1000);
                            KeyboardManager.ReleaseKey((char) Keys.S);
                        }
                        else if (next < -1 && Me.IsFlying)
                        {
                            Logging.Write(Colors.Yellow, "[ArchaeologyBuddy Stuck Helper]: We're stuck! Ascending for 5 seconds!");

                            KeyboardManager.PressKey((char) Keys.Space);
                            Thread.Sleep(5000);
                            KeyboardManager.ReleaseKey((char) Keys.Space);
                        }
                        else if (next == 0 && Me.IsFlying)
                        {
                            Logging.Write(Colors.Yellow, "[ArchaeologyBuddy Stuck Helper]: We're stuck! Dismounting!");

                            Mount.Dismount();
                        }
                    }
                    else
                    {
                        // We flying but we're stuck, so reset timer and update location
                        SwStuckTimer.Reset();
                        _wpLast = Me.Location;
                    }
                }
            }
            else
            {
                // We're not flying so just make sure timer is stopped/reset
                if (SwStuckTimer.IsRunning)
                {
                    SwStuckTimer.Stop();
                    SwStuckTimer.Reset();
                }
            }
        }
    }
}
